/********************************** (C) COPYRIGHT *******************************
* File Name          : HAL.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/04/29
* Description        : Ӳײغ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.H"	 															/* ͷļ */

/*******************************************************************************
* Function Name  : System_Init
* Description    : CH55Xʱѡú
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void System_Init( void )  
{
#if OSC_EN_XT	
	P7 = P7 & 0xF0 | 0x06;							  //ⲿǰ,P7.0ڵ͵ƽ,P7.1״̬
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	CLOCK_CFG |= bOSC_EN_XT;                          //ʹⲿ
	mDelaymS(10);
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	CLOCK_CFG &= ~bOSC_EN_INT;                        //رڲ 
	SAFE_MOD = 0x00; 
#else
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
    CLOCK_CFG |= bOSC_EN_INT;                        							/* ʹڲ */
    CLOCK_CFG &= ~bOSC_EN_XT;                        							/* رⲿ */	
#endif	
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	
#if FREQ_SYS == 48000000	
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x07;  							/* 48MHz */	
#endif	

#if FREQ_SYS == 32000000	
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x06;  							/* 32MHz */	
#endif	

#if FREQ_SYS == 24000000		
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x05;  							/* 24MHz */	
#endif

#if FREQ_SYS == 16000000		
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x04;  							/* 16MHz */
#endif	

#if FREQ_SYS == 12000000		
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x03;  							/* 12MHz */	
#endif	

#if FREQ_SYS == 3000000	
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x02;  							/* 3MHz */	
#endif

#if FREQ_SYS == 750000	
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x01;  							/* 750KHz */
#endif

#if FREQ_SYS == 187500	
	CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x00;  							/* 187.5KHz */	
#endif
	SAFE_MOD = 0x00;
}

/*******************************************************************************
* Function Name  : mDelayuS
* Description    : uSΪλʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/ 
void mDelayuS( UINT16 n )  
{
	while( n ) 
	{  
		/* total = 12~13 Fsys cycles, 1uS @Fsys=12MHz */
		++SAFE_MOD;  															/* 2 Fsys cycles, for higher Fsys, add operation here */ 
#ifdef	FREQ_SYS
#if		FREQ_SYS >= 14000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 16000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 18000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 20000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 22000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 24000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 26000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 28000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 30000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 32000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 34000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 36000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 38000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 40000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 42000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 44000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 46000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 48000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 50000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 52000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 54000000
		++SAFE_MOD;
#endif
#if		FREQ_SYS >= 56000000
		++SAFE_MOD;
#endif
#endif
		--n;
	}
}

/*******************************************************************************
* Function Name  :mDelaymS
* Description    : msʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void mDelaymS( UINT16 n )                                             
{
	while( n ) 
	{
		mDelayuS( 1000 );
		--n;
	}
}                                         

#if 0

/*******************************************************************************
* Function Name  : CH555_UART0Alter
* Description    : CH5550ӳ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH555_UART0Alter( void )
{
	PIN_FUNC |= bUART0_PIN_X;
}

/*******************************************************************************
* Function Name  : CH555_UART0Init()
* Description    : CH5550ʼ,ĬʹT1UART0Ĳʷ,ҲʹT2
                   Ϊʷ
* Input          : None
* Output         : None+
* Return         : None
*******************************************************************************/
void CH555_UART0Init( void )
{
    UINT32 x;
    UINT8 x2; 

    SM0 = 0;
    SM1 = 1;
    SM2 = 0;                                                                    /* 0ʹģʽ1 */
                                                                                /* ʹTimer1Ϊʷ */
    RCLK = 0;                                                                   /* UART0ʱ */
    TCLK = 0;                                                                   /* UART0ʱ */
    PCON |= SMOD;
    x = 10 * FREQ_SYS / UART0_BUAD / 16;                                        /* ƵעxֵҪ */                            
    x2 = x % 10;
    x /= 10;
    if( x2 >= 5 ) x++;                                                          /*  */

    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;               /* 0X20Timer1Ϊ8λԶضʱ */
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                         /* Timer1ʱѡ */
    TH1 = 0-x;                                                                  /* 12MHz,buad/12Ϊʵò */
    TR1 = 1;                                                                    /* ʱ1 */
    TI = 1;
//  REN = 1;                                                                    /* 0ʹ */
}
#endif

#if	( DEF_DEBUG_PRINTF == 1 )

/*******************************************************************************
* Function Name  : putchar
* Description    : ַͨ(921600bps@48MHZ)
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
char putchar( char c )
{
	E_DIS = 1;
	EA = 0;	
	
	/* ʼλ */
	//PIN_DEBUG = 0;
    PIN_DEBUG &= ~(1<<0);
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); 
	
	/* BIT0 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_();   

	/* BIT1 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_();  
	
	/* BIT2 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_();  
		
	/* BIT3 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_();  

	/* BIT4 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); 
	  
	/* BIT5 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_();  
	 

	/* BIT6 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
    _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); 
	

	/* BIT7 */
//	PIN_DEBUG = c & 0x01;
    if( c & 0x01)  PIN_DEBUG |= (1<<0);
    else PIN_DEBUG &= ~(1<<0);
	c >>= 1;
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
    _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_(); 
	 

//	PIN_DEBUG = 1;
    PIN_DEBUG |= (1<<0); 
    _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); 
	_nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
    _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_(); _nop_();
	_nop_(); _nop_(); _nop_(); _nop_();

	E_DIS = 0;
	EA = 1;
	return( c );
}
#endif