/******************** (C) COPYRIGHT 2013 MJX ***********************************
* File Name          : KB_TAB.H
* Author             : MJX
* Version            : V1.00
* Date               : 2021/04/29
* Description        : USB̰
*******************************************************************************/


#ifndef __KB_TAB_H__
#define __KB_TAB_H__

#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************************/
/* ͷļ */
#include "MAIN.H"	 															/* ͷļ */

/******************************************************************************/
/* ĬUSB */
UINT8C KB_Tab[ ] =				
{
	/* R0   R1   R2   R3   R4   R5    R6	R7(Ϲ)								      (ⰴ,04) */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 							/* COM14 */
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 							/* COM15 */
	0x29, 0x35, 0x2b, 0x39, 0x02, 0x01, 0x62, 0x00,								/* COM16:  esc  ~`  tab  caps-lock  shifi-L  ctr-l(ⰴ05) */
	0x3a, 0x1e, 0x14, 0x04, 0x1d, 0x08, 0x59, 0x00,								/* COM17:	F1   1!   Q     A          Z      win-l(ⰴ0b) */ 
	0x3b, 0x1f, 0x1a, 0x16, 0x1b, 0x04, 0x5a, 0x00,								/* COM18:	F2   2@   W     S          X      alt-l(ⰴ11) */
	0x3c, 0x20, 0x08, 0x07, 0x06, 0x2c, 0x5b, 0x00,								/* COM19:  F3  3#   E     D          C        Space */
	0x3d, 0x21, 0x15, 0x09, 0x19, 0x40, 0x5c, 0x00,								/* COM20:  F4  4$   R     F          V      	 alt-r(ⰴ1d) */
	0x3e, 0x22, 0x17, 0x0a, 0x05, 0x80, 0x5d, 0x00,								/* COM21:  F5  5%   T     G          B        FN		 */	                                      
	0x3f, 0x23, 0x1c, 0x0b, 0x11, 0x65, 0x5e, 0x00,								/* COM22:  F6  6^   Y     H          N      			 */  
	0x40, 0x24, 0x18, 0x0d, 0x10, 0x10, 0x5f, 0x00,								/* COM23:  F7  7&   U     J          M        Win-r(ⰴ2f) */
	0x41, 0x25, 0x0c, 0x0e, 0x36, 0x00, 0x60, 0x00,								/* COM24:  F8  8*   I     K          <,       ctr-r(ⰴ35) */
	0x42, 0x26, 0x12, 0x0f, 0x37, 0x00, 0x61, 0x00,								/* COM25:  F9  9    O     L          >.       		   */
	0x43, 0x27, 0x13, 0x33, 0x38, 0x00, 0x57, 0x00,								/* COM26: F10 0    P     ;:         /?				 */
	0x44, 0x2d, 0x2f, 0x34, 0x20, 0x50, 0x56, 0x00,								/* COM27: F11 -_   [{    '"        shift-r(ⰴ46) */
	0x45, 0x2e, 0x30, 0x28, 0x52, 0x51, 0x55, 0x00, 							/* COM28: F12 =+   ]}    \|                                     4D  */                                     
	0x46, 0x2a, 0x31, 0x00, 0x00, 0x4f, 0x54, 0x00, 							/* COM29: 0x00 Backspace                                            53 */
	0x47, 0x49, 0x4c, 0x4b, 0x00, 0x53, 0x63, 0x00, 							/* COM30: Print-screen  Insert     Delete   0x00, 		0x00, 		  */   
	0x48, 0x4a, 0x4d, 0x4e, 0x00, 0x58, 0x00, 0x00, 							/* COM31: Scroll-Lock   End        Home     0x00,  		  		 */
};

#ifdef __cplusplus
}
#endif

#endif 
