/********************************** (C) COPYRIGHT *******************************
* File Name          : KEY_LED.H
* Author             : MJX
* Version            : V1.00
* Date               : 2021/04/29
* Description        : ɨ輰LEDͷļ
*******************************************************************************/



#ifndef __KEY_LED_H__
#define __KEY_LED_H__

#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************************/
/* ͷļ */
#include "MAIN.H"	 															/* ͷļ */

/******************************************************************************/
/* غ궨 */
#define mTimer1ClkFsys( ) 		   ( T2MOD |= bTMR_CLK | bT1_CLK )              /* ʱ,ʱ=Fsys */
#define mTimer1Clk4DivFsys( ) 	   ( T2MOD &= ~bTMR_CLK; T2MOD |= bT1_CLK )     /* ʱ,ʱ=Fsys/4 */
#define mTimer1Clk12DivFsys( ) 	   ( T2MOD &= ~(bTMR_CLK | bT1_CLK ) )          /* ʱ,ʱ=Fsys/12 */
#define mTimer1CountClk( ) 		   ( TMOD |= bT1_CT )                           /* ,T1ŵ½Ч */
#define mTimer1RunCTL( SS ) 	   ( TR1 = SS ? START : STOP )  

/******************************************************************************/
/* RGBģʽغ궨 */
#define DEF_RGB_MODE0      	 	   0x00           								/*  */
#define DEF_RGB_MODE1      		   0x01           								/* ȫ */
#define DEF_RGB_MODE2      	       0x02           								/* ȫ */
#define DEF_RGB_MODE3      	       0x03          					 			/* ˸ */
#define DEF_RGB_MODE4      		   0x04          								/* 水,ɫ */

/******************************************************************************/
/* ɨض */
#define DEF_KEY_LINE_SET           16          								/* ɨ趨(ɨCOM16-COM31Ϊ16,ɨCOM14-COM3118 ) */
#define DEF_LED_LINE_SET           16           								/* LEDɨ趨(ɨCOM16-COM31Ϊ16,ɨCOM14-COM3118 ) */

#define DEF_SCAN_TIME_MAX      	   2	           								/* ɨֵ */
#define DEF_SCAN_BUFNUM_MAX        ( 5 * DEF_SCAN_TIME_MAX )	           		/* ɨ軺ֵ */
#define DEF_SCAN_LINE_MAX      	   18           								/* ɨֵ */

typedef struct			
{
	UINT8  Scan_Line;															/* ɨб */
	UINT8  Scan_LoadPtr;														/* ɨװƫ */	
	UINT8  Scan_DealPtr;														/* ɨ账ƫ */
	UINT8  Scan_ReamLen;														/* ɨδм */			   										
	UINT8  Scan_Status[ DEF_SCAN_BUFNUM_MAX ][ DEF_SCAN_LINE_MAX ];				/* ɨ״̬ */
}KB_SCAN;

/***********************************************************************************************************************/
/*  */
extern UINT8I  Time1_Count;       									      		/* ʱ1ֵ */

extern UINT8D  RGB_Mode;               											/* RGBЧģʽ */
extern UINT8I  RGB_Stauts;          											/* RGBɫת״̬ */
extern UINT8I  RGB_Load_Mode;													/* RGBװģʽ: 0: XRAM, 1: FLASH  */
extern signed char data RGB_Incre;

extern UINT16D	RGB_BufAddr;													/* RGBݻַ */
extern UINT8X	RGB_DataBuf0[ 144 ][ 4 ];      									/* RGBݻ0 */
extern UINT8X	RGB_DataBuf1[ 144 ][ 4 ];  										/* RGBݻ1 */

extern KB_SCAN KB;																/* ɨؽṹ */
extern UINT8X KB_Up_Buf[ 8 ];				  									/* ϴ */
extern UINT8X KB_Analy_Buf[ 8 ];				  								/* ̷ */
extern volatile UINT8  KB_Press_LastCount;				  						/* 1ΰ¸ */
extern volatile UINT8  KB_NonFun_Press_LastCount;				  				/* 1ΰ·ǹܼ */
extern volatile UINT8  KB_USB_UpStatus;											/* USBϴ״̬ */
extern volatile UINT8  KB_USB_SetReport;										/* SetReportֵ */

/***********************************************************************************************************************/
/*  */  
extern void	LED_LOAD_XRAM( void ); 												/* LEDֵXRAMװ */
extern void	LED_LOAD_CODE( void );												/* LEDֵCODEװ */
extern void	LED_COM_KEY_L( void );												/* ʹܵǰɨ */
extern void	LED_COM_KEY_H( void );												/* ǰɨ */

extern void CH55X_Timer1_Init( void );											/* CH55X ʱ1ʼ */
extern void CH55X_RGB_Init( void );												/* CH55XRGB LEDƳʼ */
extern void CH55X_RGB_ShowLogo( void );											/* CH55XRGB LEDʾLOGO */
extern void KB_Param_Init( void );												/* زʼ */
extern UINT8 KB_Scan_Deal( void );    	   										/* ɨ账 */
    
#ifdef __cplusplus
}
#endif

#endif

/***********************************************************************************************************************/